unit delfiles;
// The imaginary file type used in this example has a .DEL
// extension and contains one line of text representing a
// non-negative integer. These functions handle getting and
// setting the "magic number" value.

interface
USES SysUtils;

function GetDelFileNumber(const Name: String) : Integer;
function SetDelFileNumber(const Name: String; Num : Integer)
  : Integer;
function IncDelFileNumber(const Name: String; Num : Integer)
  : Integer;

implementation
function GetDelFileNumber(const Name : String) : Integer;
VAR TF : TextFile;
begin
  AssignFile(TF, Name);
  try Reset(TF);
    try ReadLn(TF, Result);
    finally CloseFile(TF);
    end;
  except
    ON E:EInOutError DO
      Result := -E.ErrorCode;
  end;
end;

function SetDelFileNumber(const Name: String; Num : Integer)
  : Integer;
VAR TF : TextFile;
begin
  AssignFile(TF, Name);
  try Rewrite(TF);
    try WriteLn(TF, Num);
    finally CloseFile(TF);
    end;
  except
    ON E: EInOutError DO
      Result := -E.ErrorCode;
  end;
  Result := 0;
end;

function IncDelFileNumber(const Name: String; Num : Integer)
  : Integer;
VAR WasNum : Integer;
begin
  WasNum := GetDelFileNumber(Name);
  IF WasNum < 0 THEN Result := WasNum
  ELSE Result := SetDelFileNumber(Name, WasNum+Num);
end;

end.
