-library delshel;

uses
  ShlObj,
  Ole2,
  Windows,
  SysUtils,
  DelphCom,
  ShellExt,
  shellCM,
  ShellCH,
  ShellPS,
  ShellEI,
  ShellDD,
  DllDebug in 'DLLDEBUG.PAS',
  ShellObj in 'SHELLOBJ.PAS',
  delfiles in 'DELFILES.PAS';

// drag/drop extension


(****** Exported DLL functions ******)
function DllGetClassObject(const RequestedClassID: TCLSID;
  const RequestedInterfaceID: TGUID; VAR ReturnedObject):
  HResult;  StdCall; Export;
VAR MyClassFactory : IMyClassFactory;
BEGIN
  Pointer(ReturnedObject) := NIL;
  // Create the class factory - unless out of memory
  try
    // Make sure the shell is asking for one of our objects
    IF IsEqualIID(CLSID_DelContextMenu, RequestedClassID) THEN
      MyClassFactory := ICMClassFactory.Create
    ELSE IF IsEqualIID(CLSID_DelCopyHook, RequestedClassID) THEN
      MyClassFactory := ICHClassFactory.Create
    ELSE IF IsEqualIID(CLSID_DelPropSheet, RequestedClassID) THEN
      MyClassFactory := IPSClassFactory.Create
    ELSE IF IsEqualIID(CLSID_DelExtractIcon, RequestedClassID) THEN
      MyClassFactory := IEIClassFactory.Create
    ELSE IF IsEqualIID(CLSID_DelDragDrop, RequestedClassID) THEN
      MyClassFactory := IDDClassFactory.Create
    ELSE
      begin
        Result := CLASS_E_CLASSNOTAVAILABLE;
        Exit;
      end;
    // Get the requested interface
    Result := MyClassFactory.QueryInterface(RequestedInterfaceID,
      ReturnedObject);
    IF FAILED(Result) THEN MyClassFactory.Free;
  except
    Result := E_OUTOFMEMORY;
    Exit;
  end;
END;

// DLLCanUnloadNow is contained in the DelphCom unit

Exports
  DllGetClassObject   name 'DllGetClassObject' resident,
  DllCanUnloadNow     name 'DllCanUnloadNow' resident;

begin
end.


