unit DllDebug;
// A call to the Loggit function sends a string-message to the
// Logger program defined in LOGGER.DPR. It functions as a very
// simple-minded kind of debugging, allowing your program to
// signal the current value of a variable, or whether a certain
// function was activated. And if the Logger program isn't running,
// the messages do no harm.

interface
USES Windows, Ole2, OleAuto, Shlobj, Messages;

procedure Loggit(const S : String);

function NameOfIID(const IID : TIID) : String;

implementation

VAR WM_LOGGIT : Integer;

procedure Loggit(const S : String);
VAR MyAtom : TAtom;
begin
  MyAtom := GlobalAddAtom(PChar(S));
  SendMessage(-1, WM_LOGGIT, MyAtom, 0);
  GlobalDeleteAtom(MyAtom);
end;

function NameOfIID(const IID : TIID) : String;
// Add any other IIDs you're interested in
begin
  IF IsEqualIID(IID, IID_IUnknown) THEN
    Result := 'IID_IUnknown'
  ELSE IF IsEqualIID(IID, IID_IClassFactory) THEN
    Result := 'IID_IClassFactory'
  ELSE IF IsEqualIID(IID, IID_IContextMenu) THEN
    Result := 'IID_IContextMenu'
  ELSE IF IsEqualIID(IID, IID_IShellFolder) THEN
    Result := 'IID_IShellFolder'
  ELSE IF IsEqualIID(IID, IID_IShellExtInit) THEN
    Result := 'IID_IShellExtInit'
  ELSE IF IsEqualIID(IID, IID_IShellPropSheetExt) THEN
    Result := 'IID_IShellPropSheetExt'
  ELSE IF IsEqualIID(IID, IID_IExtractIcon) THEN
    Result := 'IID_IExtractIcon'
  ELSE IF IsEqualIID(IID, IID_IPersistFile) THEN
    Result := 'IID_IPersistFile'
  ELSE IF IsEqualIID(IID, IID_IShellLink) THEN
    Result := 'IID_IShellLink'
  ELSE IF IsEqualIID(IID, IID_IShellCopyHook) THEN
    Result := 'IID_IShellCopyHook'
  ELSE IF IsEqualIID(IID, IID_IFileViewer) THEN
    Result := 'IID_IFileViewer'
  ELSE IF IsEqualIID(IID, IID_IEnumIDList) THEN
    Result := 'IID_IEnumIDList'
  ELSE IF IsEqualIID(IID, IID_IFileViewerSite) THEN
    Result := 'IID_IFileViewerSite'
  ELSE Result := ClassIDToString(IID);
end;

initialization
  WM_LOGGIT := RegisterWindowMessage('Debugging Status Message');
end.

