{$APPTYPE CONSOLE}
program GUIDs;

uses SysUtils, OLE2, OLEAuto;

function GUIDToConstant(GUID: TGUID) : String;
begin
  WITH GUID DO
    Result := Format('(D1:$%.8x; D2:$%.4x; D3:$%.4x; D4:'+
      ' ($%.2x,$%.2x,$%.2x,$%.2x,$%.2x,$%.2x,$%.2x,$%.2x))',
      [D1,D2,D3,D4[0],D4[1],D4[2],D4[3],D4[4],D4[5],D4[6],D4[7]]);
end;

var
  N, NumNeeded : Integer;
  GUID         : TGUID;
CONST suffixes : ARRAY[Boolean] OF String[1] = ('s', '');
begin
  IF ParamCount > 0 THEN
    NumNeeded := StrToIntDef(ParamStr(1), 1)
  ELSE NumNeeded := 1;
  WriteLn(Format('Delphi-based GUID generator: %d GUID%s requested',
    [NumNeeded, suffixes[NumNeeded=1]]));
  WriteLn('First line in string form, second in Delphi CONST form');
  WriteLn;
  CASE OleInitialize(Nil) OF
    S_OK    : ; // initialized for first time
    S_False : ; // was already initialized
    ELSE
      WriteLn('Could not initialize OLE engine');
      Exit;
  END;
  try
    FOR N := 1 TO NumNeeded DO
      IF CoCreateGUID(GUID) = S_OK then
        begin
          WriteLn(ClassIDToString(GUID));
          WriteLn(GUIDToConstant(GUID));
          WriteLn;
        end
      ELSE
        begin
          WriteLn('Error in CoCreateGUID.');
          Break;
        end;
  finally
    OleUninitialize;
  end;
end.

