{$APPTYPE CONSOLE}
program regunreg;
uses SysUtils, Windows, Registry;

const
  CMShellExtension='{6A5EF9E1-DFCE-11CF-9A34-444553540000}';
  CHShellExtension='{6A5EF9E2-DFCE-11CF-9A34-444553540000}';
  PSShellExtension='{6A5EF9E3-DFCE-11CF-9A34-444553540000}';
  EIShellExtension='{6A5EF9E4-DFCE-11CF-9A34-444553540000}';
  DDShellExtension='{6A5EF9E5-DFCE-11CF-9A34-444553540000}';
  delShelStr='\DelShellFile\shellex\';
  cmStr=delShelStr+'ContextMenuHandlers\DelContextMenu';
  ddStr='\Directory\shellex\DragDropHandlers\DelDragDrop';
  psStr=delShelStr+'PropertySheetHandlers\DelPropertySheet';
  eiStr='\DelShellFile\shellex\IconHandler';
  chStr1='\directory\shellex\CopyHookHandlers\DelCopyHook';
  chStr2='\*\shellex\CopyHookHandlers\DelCopyHook';

procedure DoRegister;
VAR
  buffer : String;
  TR     : TRegistry;

  procedure RegExt(const GuidStr, name : String);
  begin
    TR.OpenKey('\CLSID\'+GuidStr, True);
    TR.WriteString('', 'Delphi '+name+' Extension');
    TR.OpenKey('InprocServer32', True);
    TR.WriteString('', Buffer);
    TR.WriteString('ThreadingModel', 'Apartment');
  end;

begin
  TR := TRegistry.Create;
  WITH TR DO
    try
      RootKey := HKEY_CLASSES_ROOT;
      OpenKey('\.del', True);
      WriteString('', 'DelShellFile');    // register DEL file type
      OpenKey(cmStr, True);
      WriteString('', CMShellExtension);  // context menu handler
      OpenKey(ddStr, True);
      WriteString('', DDShellExtension);  // context menu handler
      OpenKey(psStr, True);
      WriteString('', PSShellExtension);  // property sheet handler
      OpenKey(eiStr, True);
      WriteString('', EIShellExtension);  // extract icon handler
      OpenKey('\DelShellFile\DefaultIcon', True);
      WriteString('', '%1');
      // install the copy hook handler
      OpenKey(chStr1, True);
      WriteString('', CHShellExtension);
      OpenKey(chStr2, True);
      WriteString('', CHShellExtension);

      // now register the shell extensions themselves
      SetLength(Buffer, MAX_PATH);
      GetModuleFilename(hInstance, PChar(buffer), MAX_PATH);
      buffer := ExtractFileDir(Buffer) + '\delshel.dll';

      RegExt(CMShellExtension, 'Context Menu');
      RegExt(CHShellExtension, 'Copy Hook');
      RegExt(PSShellExtension, 'Property Sheet');
      RegExt(EIShellExtension, 'Extract Icon');
      RegExt(DDShellExtension, 'Drag-Drop');
    finally
      free;
    end;
end;

PROCEDURE Unregister;
begin
  WITH TRegistry.Create DO
    try
      RootKey := HKEY_CLASSES_ROOT;
      DeleteKey(cmStr);
      DeleteKey(ddStr);
      DeleteKey(chStr1);
      DeleteKey(chStr2);
      DeleteKey(psStr);
      DeleteKey(eiStr);
      DeleteKey('\DelShellFile\DefaultIcon');
      DeleteKey('\CLSID\'+CMShellExtension);
      DeleteKey('\CLSID\'+CHShellExtension);
      DeleteKey('\CLSID\'+PSShellExtension);
      DeleteKey('\CLSID\'+EIShellExtension);
      DeleteKey('\CLSID\'+DDShellExtension);
    finally
      free;
    end;
end;

begin
  IF ParamCount = 0 THEN
    begin
      WriteLn('Registering Delphi Shell Extension examples');
      WriteLn('Enter "REGUNREG X" to un-register them');
      DoRegister;
    end
  else
    begin
      WriteLn('UN-Registering Delphi Shell Extension examples');
      UnRegister;
    end;
end.
