{Minimal implementation of ShlObj.PAS for Delphi 2.0 users}
unit ShellObj;

interface

uses Windows, OLE2;

const
  IID_IContextMenu : TGUID = (
    D1:$000214E4; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IShellExtInit : TGUID = (
    D1:$000214E8; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IShellPropSheetExt : TGUID = (
    D1:$000214E9; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IExtractIcon : TGUID = (
    D1:$000214EB; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IShellCopyHook : TGUID = (
    D1:$000214EF; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));

type
  PSHItemID = ^TSHItemID;
  TSHItemID = packed record           { mkid }
    cb: Word;                         { Size of the ID (including cb itself) }
    abID: array[0..0] of Byte;        { The item ID (variable length) }
  end;

{ TItemIDList -- List if item IDs (combined with 0-terminator) }

  PItemIDList = ^TItemIDList;
  TItemIDList = packed record         { idl }
     mkid: TSHItemID;
   end;


const
  GCS_VERB         = $00000000;     { canonical verb }
  GCS_HELPTEXT     = $00000001;     { help text (for status bar) }

type
  PCMInvokeCommandInfo = ^TCMInvokeCommandInfo;
  TCMInvokeCommandInfo = packed record
    cbSize: DWORD;        { must be sizeof(CMINVOKECOMMANDINFO) }
    fMask: DWORD;         { any combination of CMIC_MASK_* }
    hwnd: HWND;           { might be NULL (indicating no owner window) }
    lpVerb: LPCSTR;       { either a string of MAKEINTRESOURCE(idOffset) }
    lpParameters: LPCSTR; { might be NULL (indicating no parameter) }
    lpDirectory: LPCSTR;  { might be NULL (indicating no specific directory) }
    nShow: Integer;       { one of SW_ values for ShowWindow() API }
    dwHotKey: DWORD;
    hIcon: THandle;
  end;

const
  GIL_SIMULATEDOC  = $0001      { simulate this document icon for this };
  GIL_PERINSTANCE  = $0002      { icons from this class are per instance (each file has its own) };
  GIL_PERCLASS     = $0004      { icons from this class per class (shared for all files of this type) };
  GIL_NOTFILENAME  = $0008      { location is not a filename, must call .Extract };
  GIL_DONTCACHE    = $0010      { this icon should not be cached };

function SHGetPathFromIDList(pidl: PItemIDList; pszPath: LPSTR): BOOL; stdcall;

const
  SHCNE_UPDATEITEM  = $00002000;
  SHCNF_PATH        = $0001;
  SHCNF_FLUSHNOWAIT = $2000;

procedure SHChangeNotify(wEventId: Longint; uFlags: UINT;
  dwItem1, dwItem2: Pointer); stdcall;

implementation

const shell32 = 'shell32.dll';

function SHGetPathFromIDList; external shell32 name 'SHGetPathFromIDList';
procedure SHChangeNotify; external shell32 name 'SHChangeNotify';

end.

