unit Utility;

interface

uses
  Windows, FolderScan;

  procedure InvokeAction(idCmd: UINT);
  function WideStringAsPChar(S: String): PChar;
  function GetMenuItemById(idCmd: UINT): PExplodeMenuItem;


implementation

uses
  ShellApi;

function WideStringAsPChar(S: String): PChar;
var
  I: Integer;
  WideStr: array[0..511] of Char;
begin
  FillChar(WideStr, SizeOf(WideStr), 0);
  for I := 0 to Length(S) -1 do
  begin
    if I = 254 then
      Break;
    WideStr[I*2] := S[I];
  end;
  Result := WideStr;
end;


function GetMenuItemById(idCmd: UINT): PExplodeMenuItem;
var
  I: Integer;
  emi: PExplodeMenuItem;
begin
  Result := nil;
  for I := 0 to ExplodeMenuItems.Count -1 do
  begin
    emi := PExplodeMenuItem(ExplodeMenuItems[I]);
    if emi.IdCmd = idCmd then
    begin
      Result := emi;
      Break;
    end;
  end;
end;


procedure DisplayProperties(FileName: String);
// Display Properties dialog
var
  sei: TShellExecuteInfo;
begin
  with sei do
  begin
    FillChar(sei, SizeOf(sei), 0);
    cbSize := SizeOf(sei);
    fMask := SEE_MASK_INVOKEIDLIST;
    lpVerb := PChar('properties');
    lpFile := PChar(FileName);
  end;
  if not ShellExecuteEx(@sei) then
    ErrorMessage('Could not display properties');
end;


procedure InvokeAction(idCmd: UINT);
var
  emi: PExplodeMenuItem;
begin
//  ShowMessage('InvokeAction: '+IntToStr(idCmd));
  emi := GetMenuItemById(idCmd);
  if emi <>  nil then
    DisplayProperties(emi.FileName);
end;

end.
 