library VersInfo;

uses
  Ole2,
  Windows,
  DelphCom,
  ShellExt,
  shellCM,
  Shortcut in 'Shortcut.pas',
  Version in 'Version.pas',
  FolderScan in 'FolderScan.pas',
  Utility in 'Utility.pas';

// context menu extension


(****** Exported DLL functions ******)
function DllGetClassObject(const RequestedClassID: TCLSID;
  const RequestedInterfaceID: TGUID; var ReturnedObject): HResult; stdcall; export;
var
  MyClassFactory: IMyClassFactory;
begin
  Pointer(ReturnedObject) := nil;
  // Create the class factory - unless out of memory
  try
    // Make sure the shell is asking for a ctxmenu object
    if IsEqualIID(CLSID_VerInfoContextMenu, RequestedClassID) then
      MyClassFactory := ICMClassFactory.Create
    else
      begin
        Result := CLASS_E_CLASSNOTAVAILABLE;
        Exit;
      end;
    // Get the requested interface
    Result := MyClassFactory.QueryInterface(RequestedInterfaceID, ReturnedObject);
    if FAILED(Result) then
      MyClassFactory.Free;
  except
    Result := E_OUTOFMEMORY;
    Exit;
  end;
end;

// DLLCanUnloadNow is contained in the DelphCom unit

exports
  DllGetClassObject   name 'DllGetClassObject',
  DllCanUnloadNow     name 'DllCanUnloadNow';
//  DllRegisterServer,
//  DllUnregisterServer;

begin
end.

